From ea780b4ae8833b5e28e122d3704964e8c4a81965 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?Pavel=20B=C5=99ezina?= <pbrezina@redhat.com>
Date: Wed, 9 Dec 2015 13:04:35 +0100
Subject: [PATCH] sss_override: improve --debug description

Resolves:
https://fedorahosted.org/sssd/ticket/2813
---
 src/man/include/debug_levels.xml   | 23 ++---------------------
 src/man/include/debug_services.xml | 21 +++++++++++++++++++++
 src/man/po/po4a.cfg                |  1 +
 src/man/sss_debuglevel.8.xml       |  4 +++-
 src/man/sss_override.8.xml         |  4 +++-
 src/man/sssd.8.xml                 |  5 ++++-
 src/man/sssd.conf.5.xml            |  5 ++++-
 7 files changed, 38 insertions(+), 25 deletions(-)
 create mode 100644 src/man/include/debug_services.xml

diff --git a/src/man/include/debug_levels.xml b/src/man/include/debug_levels.xml
index 0711cb5600b90b1c7dfc4a7728beff5b245f866a..d0f52b15e31a2b53d654f4a8cad31b30ca5abd1b 100644
--- a/src/man/include/debug_levels.xml
+++ b/src/man/include/debug_levels.xml
@@ -1,4 +1,4 @@
-<listitem>
+<blockquote>
     <para>
         SSSD supports two representations for specifying the debug level. The
         simplest is to specify a decimal value from 0-9, which represents
@@ -7,25 +7,6 @@
         disable specific levels (such as if you wish to suppress a level).
     </para>
     <para>
-        Please note that each SSSD service logs into its own log
-        file. Also please note that enabling <quote>debug_level</quote>
-        in the <quote>[sssd]</quote> section only enables debugging just
-        for the sssd process itself, not for the responder or provider
-        processes. The <quote>debug_level</quote> parameter should be
-        added to all sections that you wish to produce debug logs from.
-    </para>
-    <para>
-        In addition to changing the log level in the config file using
-        the <quote>debug_level</quote> parameter, which is persistent, but
-        requires SSSD restart, it is also possible to change the debug level
-        on the fly using the
-        <citerefentry>
-            <refentrytitle>sss_debuglevel</refentrytitle>
-            <manvolnum>8</manvolnum>
-        </citerefentry>
-        tool.
-    </para>
-    <para>
         Currently supported debug levels:
     </para>
     <para>
@@ -97,4 +78,4 @@
     <para>
         <emphasis>Default</emphasis>: 0
     </para>
-</listitem>
+</blockquote>
\ No newline at end of file
diff --git a/src/man/include/debug_services.xml b/src/man/include/debug_services.xml
new file mode 100644
index 0000000000000000000000000000000000000000..6595f84be7e3d0b44ab0ab7cb5697ae26acbb8d2
--- /dev/null
+++ b/src/man/include/debug_services.xml
@@ -0,0 +1,21 @@
+<blockquote>
+    <para>
+        Please note that each SSSD service logs into its own log
+        file. Also please note that enabling <quote>debug_level</quote>
+        in the <quote>[sssd]</quote> section only enables debugging just
+        for the sssd process itself, not for the responder or provider
+        processes. The <quote>debug_level</quote> parameter should be
+        added to all sections that you wish to produce debug logs from.
+    </para>
+    <para>
+        In addition to changing the log level in the config file using
+        the <quote>debug_level</quote> parameter, which is persistent, but
+        requires SSSD restart, it is also possible to change the debug level
+        on the fly using the
+        <citerefentry>
+            <refentrytitle>sss_debuglevel</refentrytitle>
+            <manvolnum>8</manvolnum>
+        </citerefentry>
+        tool.
+    </para>
+</blockquote>
diff --git a/src/man/po/po4a.cfg b/src/man/po/po4a.cfg
index 67e87ba7006f0bb1346e5b845428f2bed1a324db..9347cedd82d9e661d9429841142415f69b10ce68 100644
--- a/src/man/po/po4a.cfg
+++ b/src/man/po/po4a.cfg
@@ -33,6 +33,7 @@
 [type:docbook] include/param_help.xml $lang:$(builddir)/$lang/include/param_help.xml opt:"-k 0"
 [type:docbook] include/param_help_py.xml $lang:$(builddir)/$lang/include/param_help_py.xml opt:"-k 0"
 [type:docbook] include/debug_levels.xml $lang:$(builddir)/$lang/include/debug_levels.xml opt:"-k 0"
+[type:docbook] include/debug_services.xml $lang:$(builddir)/$lang/include/debug_services.xml opt:"-k 0"
 [type:docbook] include/experimental.xml $lang:$(builddir)/$lang/include/experimental.xml opt:"-k 0"
 [type:docbook] include/local.xml $lang:$(builddir)/$lang/include/local.xml opt:"-k 0"
 [type:docbook] include/seealso.xml $lang:$(builddir)/$lang/include/seealso.xml opt:"-k 0"
diff --git a/src/man/sss_debuglevel.8.xml b/src/man/sss_debuglevel.8.xml
index eb11540d8cf66bf7ad4c16bb9bcb296aedc54965..745daf0ca31eadb083ff517816a85a1aa5a1a2e2 100644
--- a/src/man/sss_debuglevel.8.xml
+++ b/src/man/sss_debuglevel.8.xml
@@ -58,7 +58,9 @@
                 <term>
                     <replaceable>NEW_DEBUG_LEVEL</replaceable>
                 </term>
-                <xi:include xmlns:xi="http://www.w3.org/2001/XInclude" href="include/debug_levels.xml" />
+                <listitem>
+                    <xi:include xmlns:xi="http://www.w3.org/2001/XInclude" href="include/debug_levels.xml" />
+                </listitem>
             </varlistentry>
         </variablelist>
     </refsect1>
diff --git a/src/man/sss_override.8.xml b/src/man/sss_override.8.xml
index ef73aee981a34f9679907bb793126c0c19a50cef..e86a43d1b8d649cbc6658da78a24abaf64022c86 100644
--- a/src/man/sss_override.8.xml
+++ b/src/man/sss_override.8.xml
@@ -266,7 +266,9 @@
                     <option>--debug</option>
                     <replaceable>LEVEL</replaceable>
                 </term>
-                <xi:include xmlns:xi="http://www.w3.org/2001/XInclude" href="include/debug_levels.xml" />
+                <listitem>
+                    <xi:include xmlns:xi="http://www.w3.org/2001/XInclude" href="include/debug_levels.xml" />
+                </listitem>
             </varlistentry>
         </variablelist>
     </refsect1>
diff --git a/src/man/sssd.8.xml b/src/man/sssd.8.xml
index 923da6824907f0d2d140d9ca83f87338e7664f83..08ae45f900c562d6120a686263ec5b6d981025fc 100644
--- a/src/man/sssd.8.xml
+++ b/src/man/sssd.8.xml
@@ -46,7 +46,10 @@
                     <option>-d</option>,<option>--debug-level</option>
                     <replaceable>LEVEL</replaceable>
                 </term>
-                <xi:include xmlns:xi="http://www.w3.org/2001/XInclude" href="include/debug_levels.xml" />
+                <listitem>
+                    <xi:include xmlns:xi="http://www.w3.org/2001/XInclude" href="include/debug_levels.xml" />
+                    <xi:include xmlns:xi="http://www.w3.org/2001/XInclude" href="include/debug_services.xml" />
+                </listitem>
             </varlistentry>
             <varlistentry>
                 <term>
diff --git a/src/man/sssd.conf.5.xml b/src/man/sssd.conf.5.xml
index c5d509ea9b5186944ae467a20ef8b6a3fe2720a0..f6bec4af611f664193c4769693e7c3325bd2b1e9 100644
--- a/src/man/sssd.conf.5.xml
+++ b/src/man/sssd.conf.5.xml
@@ -67,7 +67,10 @@
               <variablelist>
                 <varlistentry>
                     <term>debug_level (integer)</term>
-                    <xi:include xmlns:xi="http://www.w3.org/2001/XInclude" href="include/debug_levels.xml" />
+                    <listitem>
+                        <xi:include xmlns:xi="http://www.w3.org/2001/XInclude" href="include/debug_levels.xml" />
+                        <xi:include xmlns:xi="http://www.w3.org/2001/XInclude" href="include/debug_services.xml" />
+                    </listitem>
                 </varlistentry>
                 <varlistentry>
                     <term>debug_timestamps (bool)</term>
-- 
2.1.0